import * as smartlogInterfaces from '@push.rocks/smartlog-interfaces';
import type { EdgeWorker } from '../classes.edgeworker.js';

export class SmartlogDestination implements smartlogInterfaces.ILogDestination {
  public edgeWorkerRef: EdgeWorker;

  constructor(edgeworkerRefArg: EdgeWorker) {
    this.edgeWorkerRef = edgeworkerRefArg;
  }

  public async handleLog(logPackageArg: smartlogInterfaces.ILogPackage) {
    if (this.edgeWorkerRef.options.smartlogConfig) {
      const requestBody: smartlogInterfaces.ILogPackageAuthenticated = {
        auth: this.edgeWorkerRef.options.smartlogConfig.token,
        logPackage: logPackageArg,
      };
      await fetch(this.edgeWorkerRef.options.smartlogConfig.endpoint, {
        method: 'POST',
        headers: {
          'content-type': 'application/json',
        },
        body: JSON.stringify(requestBody),
      });
    }
  }
}
